<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="systemName+'号'" prop="usercode">
        <el-input
            v-model="queryParams.usercode"
            :placeholder="'请输入'+systemName+'号'"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="手机号" prop="mobile">
        <el-input
            v-model="queryParams.mobile"
            placeholder="请输入手机号"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="类型" prop="type">
        <el-select v-model="queryParams.type" clearable size="small">
          <el-option
              v-for="dict in userErrorLogTypeList"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
              @keyup.enter.native="handleQuery"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="发生地点" prop="homeIndex">
        <el-select v-model="queryParams.homeIndex" clearable size="small">
          <el-option
              v-for="dict in userErrorLogHomeIndexList"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
              @keyup.enter.native="handleQuery"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-table v-loading="loading" :data="userErrorLogList" @selection-change="handleSelectionChange">
      <el-table-column :label="systemName+'号'" align="center" prop="usercode"/>
      <el-table-column label="手机号" align="center" prop="mobile"/>
      <el-table-column label="昵称" align="center" prop="nickname"/>
      <el-table-column label="头像" align="center" prop="avatar">
        <template v-slot="scope">
          <image-avatar :src="scope.row.avatar"/>
        </template>
      </el-table-column>
      <el-table-column label="性别" align="center" prop="gender">
        <template v-slot="scope">
          <cai-dict-tag :options="genderList" :value="scope.row.gender"/>
        </template>
      </el-table-column>
      <el-table-column label="类型" align="center" prop="type" >
        <template v-slot="scope">
          <cai-dict-tag :options="userErrorLogTypeList" :value="scope.row.type"/>
        </template>
      </el-table-column>
      <el-table-column label="发生地点" align="center" prop="homeIndex" >
        <template v-slot="scope">
          <cai-dict-tag :options="userErrorLogHomeIndexList" :value="scope.row.homeIndex"/>
        </template>
      </el-table-column>
      <el-table-column label="发生时间" align="center" prop="createTime" />
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

  </div>
</template>

<script>
import { listUserErrorLog, getUserErrorLog, delUserErrorLog, addUserErrorLog, updateUserErrorLog } from "@/api/cai/userErrorLog";
import { userErrorLogHomeIndexList, userErrorLogTypeList,genderList } from '@/constant/statusMap'

export default {
  name: "UserErrorLog",
  data() {
    return {
      userErrorLogTypeList,userErrorLogHomeIndexList,genderList,
      systemName: process.env.VUE_APP_SYSTEM_HOME,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 用户异常记录表格数据
      userErrorLogList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        type: undefined,
        homeIndex: undefined,
        usercode: undefined,
        mobile: undefined,
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询用户异常记录列表 */
    getList() {
      this.loading = true;
      listUserErrorLog(this.queryParams).then(response => {
        this.userErrorLogList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加用户异常记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.loading = true;
      this.reset();
      const id = row.id || this.ids
      getUserErrorLog(id).then(response => {
        this.loading = false;
        this.form = response.data;
        this.open = true;
        this.title = "修改用户异常记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.buttonLoading = true;
          if (this.form.id != null) {
            updateUserErrorLog(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          } else {
            addUserErrorLog(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除用户异常记录编号为"' + ids + '"的数据项？').then(() => {
        this.loading = true;
        return delUserErrorLog(ids);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('cai/userErrorLog/export', {
        ...this.queryParams
      }, `userErrorLog_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
